<template>
  <div class="single-todo-wrapper">
    <div class="row">
      <div class="todo-item-wrapper">
        <h4 class="todo-item-title">
          <input type="text" placeholder="Input title here" v-model="editableTodo.title">
        </h4>
        <div class="todo-item-buttons-wrapper">
          <action-todo-button :placeholder="'Save TODO'" :todo="editableTodo" :action="'add'" :id="this.$route.params.id"></action-todo-button>
          <action-todo-button :placeholder="'Cancel changes'" :action="'cancel'" :id="this.$route.params.id"></action-todo-button>
          <action-todo-button v-if="$route.params.id !== 'new'" :placeholder="'Delete TODO'" :action="'delete'" :id="$route.params.id"></action-todo-button>
          <action-todo-button v-else :placeholder="'Delete TODO'" :action="'delete-new'"></action-todo-button>
          <action-todo-button :class="{'disabled' : !canUndo}" @undo="undo" :placeholder="'Remove last action'" :action="'remove'" :id="$route.params.id"></action-todo-button>
          <action-todo-button :class="{'disabled' : !canRedo}" @redo="redo" :placeholder="'Revert last action'" :action="'revert'" :id="$route.params.id"></action-todo-button>
        </div>
        <ul class="todo-item-tasks">
          <li v-for="(task, index) in editableTodo.items" :key="'task-' + index">
            <input :name="'task-' + index" type="checkbox" v-model="task.check" @change="changeCheckbox()">
            <label :for="'task-' + index">
              <input type="text" @blur="log(editableTodo.items)" v-model="task.name">
            </label>
            <div class="todo-inner-button-wrapper">
              <div class="button delete" @click="deleteTodoLine(index)">
                Delete Todo Item
              </div>
            </div>
          </li>
        </ul>
        <div class="add-line-wrapper">
          <p v-if="editableTodo.items.length === 0">Right now your todo list is empty, click the button to add some.</p>
          <div class="button add" @click="addTodoLine">
            Add Todo Item
          </div>
        </div>
      </div>
    </div>
    <modal-wrapper @cancelChanges="clearChanges"></modal-wrapper>
  </div>
</template>

<script>
  import ActionTodoButton from "../components/buttons/actionTodoButton";
  import ModalWrapper from "../components/helpers/modalWrapper";
  export default {
    name: "singleTodo",
    components: {ModalWrapper, ActionTodoButton},
    data () {
      return {
        editableTodo: {
          title: '',
          items: []
        },
        logList: [[]],
        logIndex: 0
      }
    },
    computed: {
      canUndo: function() {
        return this.logIndex > 0
      },
      canRedo: function() {
        return this.logList.length - 1 - this.logIndex > 0
      },
      getTodo () {
        //getTodo structure = {title,items[{name,check}]}
        return this.$route.params.id !== 'new' ? this.$store.getters.getTodoById(this.$route.params.id) : null
      }
    },
    methods: {
      //Save Check in history
      changeCheckbox () {
        this.log(this.editableTodo.items)
      },
      //Clear button
      clearChanges () {
        if (this.getTodo !== null) {
          this.editableTodo = this._.cloneDeep(this.getTodo)
        } else {
          this.editableTodo = {
            title: '',
            items: []
          }
        }

        //Empty history
        this.logIndex = 0
        this.logList.splice(this.logIndex)
        this.logList.push(this._.cloneDeep(this.editableTodo.items))
        this.$modal.hide('confirm')
      },
      //Add item also to history
      addTodoLine () {
        this.editableTodo.items.push({name: '',check: false})
        this.log(this.editableTodo.items)
      },
      //Remove item, also add history line
      deleteTodoLine (id) {
        this.editableTodo.items.splice(id, 1);
        this.log(this.editableTodo.items)
      },
      //History method
      log (todoList) {
        this.logIndex += 1
        this.logList.splice(this.logIndex)
        this.logList.push(this._.cloneDeep(todoList))
      },
      undo: function() {
        if (this.canUndo) {
          this.logIndex -= 1
          this.editableTodo.items = this.logList[this.logIndex]
        }
      },
      redo: function() {
        if (this.canRedo) {
          this.logIndex += 1
          this.editableTodo.items = this.logList[this.logIndex]
        }
      }
    },
    mounted() {
      //Check if this is new Note or we are changing the existing one
      if (this.$route.params.id !== 'new' && this.getTodo === undefined) {
        this.$router.push('/')
      }
      if (this.getTodo !== null) {
        this.editableTodo = this._.cloneDeep(this.getTodo)
      }

      //Set History array
      this.logIndex = 0
      this.logList.splice(this.logIndex)
      this.logList.push(this._.cloneDeep(this.editableTodo.items))
    }
  }
</script>

<style lang="scss" scoped>
  input {
    margin: 0 10px 0 0;
  }
  .add-line-wrapper {
    .button {
      &.add {
        padding: 10px 15px;
        display: block;
        text-align: center;
      }
    }
  }
  .todo-inner-button-wrapper {
    .button {
      padding: 10px 15px;
    }
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    -o-transform: translateY(-50%);
    -moz-transform: translateY(-50%);
    -webkit-transform: translateY(-50%);
    -ms-transform: translateY(-50%);
    right: 10px;
  }
  .todo-item-buttons-wrapper {
    position: absolute;
    top: 0;
    right: 0;
  }
  .todo-item-wrapper {
    position: relative;
  }
  .todo-item-tasks {
    list-style: none;
    padding-left: 0;
    li {
      position: relative;
      padding: 10px;
      margin: 0 0 10px 0;
      border: 1px solid #333333;
      border-radius: 5px;
      -o-border-radius: 5px;
      -moz-border-radius: 5px;
      -webkit-border-radius: 5px;
      -ms-border-radius: 5px;
      -webkit-box-shadow: 0px 5px 5px -2px rgba(0,0,0,0.75);
      -moz-box-shadow: 0px 5px 5px -2px rgba(0,0,0,0.75);
      box-shadow: 0px 5px 5px -2px rgba(0,0,0,0.75);
    }
  }
  /*Some small responsiveness*/
  /* 1080px */
  @media only screen and (max-width: 1080px){
    .todo-item-buttons-wrapper {
      position: static;
      top: auto;
      right: auto;
      .button {
        margin-bottom: 10px;
      }
    }
  }
  /* 480px */
  @media only screen and (max-width: 480px){
    input {
      margin-bottom: 10px;
    }
    .todo-inner-button-wrapper {
      text-align: center;
      position: static;
      top: auto;
      transform: translateY(0);
      -o-transform: translateY(0);
      -moz-transform: translateY(0);
      -webkit-transform: translateY(0);
      -ms-transform: translateY(0);
      right: auto;
      .button {
        display: block;
      }
    }
  }
</style>